//+------------------------------------------------------------------+
//|                                                   10points 3.mq4 |
//|                              Copyright  2005, Alejandro Galindo |
//|                                              http://elCactus.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, Alejandro Galindo"
#property link      "http://elCactus.com"

//
//
//
//
//

extern int    Magic                          = 234567;
extern bool   EcnBroker                      = true;
extern double TakeProfit                     = 500;
extern double Lots                           = 0.01;
extern double InitialStop                    = 0;
extern int    BreakEvenAtProfit              = 0;
extern int    BreakEvenShift                 = 0;           // Move the breakeven point up or down around the order open price
extern int    TrailingStop                   = 20;
extern bool   OnlyTrailAfterProfit           = true;        // Trailing Stop will only trails when order is profitable
extern int    MaxTrades                      = 10;
extern int    Pips                           = 20;
extern int    slippage                       = 5;
extern int    SecureProfit                   = 5;
extern int    AccountProtection              = 1;
extern int    OrderstoProtect                = 3;
extern int    ReverseCondition               = 0;
extern bool   CloseOnTrendRev                = true;
extern int    bar                            = 1;

extern bool   mm                             = true;       // if True the lots size will increase based on account size (I don't recomend use MM with a martingale EA)
extern double risk                           = 0.1;        // risk to calculate the lots size (only if mm is enabled)
extern double lotincrease                    = 1.63;
extern bool   SpreadProtection               = true;       // If the spread is widen than normal (News time) we will not open positions or continue positions until it normalize
extern int    PipTolerance                   = 5;          // value in pips over normal spread to activate the SpreadProtection.

extern string _acctprotect                   = "Account Protection";
extern int    FloatingLossProtection         = 50;         // Percent of FLOATING LOSS to stop opening new positions after closed ones(Percent of Balance)
extern double MarginProtection               = 50.0;       // Percent of free margin to stop opening new positions after closed ones
extern double MarginProtection2              = 50;         // Percent of free margin to START AccountProtection Function
extern bool   EquityProtection               = false;      // if true, then the expert will protect the account equity to the percent specified
extern int    AccountEquityPercentProtection = 50;         // percent of the account Equity left to activate a hard stop loss on a set of trades
extern bool   AccountMoneyProtection         = false;      // if true, then the expert will protect the account money to the amount specified
extern double AccountMoneyProtectionValue    = 50.00;      // Amount of Equity money To Trigger a Hard Stop Loss on ALL trades.This is a final Stop loss.

extern string _time                          = "Time Filter";
extern int    StartHour                      = 0;          // Start Hour of Trade Session 
extern int    StartMinute                    = 0;          // Start Minute of Trade Session 
extern int    EndHour                        = 23;         // End Hour of Trade Session
extern int    EndMinute                      = 0;          // End Hour of Trade Session

extern string Digitals_is                    = "Digitals Settings";
extern int    NormPeriod                     = 100;
extern int    RbciPrice                      = PRICE_MEDIAN;
extern int    T3Period                       = 4;
extern double T3Hot                          = 1.0;
extern bool   T3Original                     = false;
extern int    rbcitf1                        = 240;
extern int    rbcitf2                        = 60;
extern int    stlmtf                         = 0;
extern int    fatltf                         = 0;
extern int    satltf                         = 0;


//
//
//
//
//

int    dg;
int    OpenOrders=0, cnt=0;
int    mode=0;
int    lotsize;
int    PreviousOpenOrders=0;
int    LastTicket=0, LastType=0;
int    myOrderType=0,DontContinue;
int    TrendType=0;

bool   ContinueOpening = True, AccountisNormal;

double Profit=0;
double PipValue=0;
double sl=0, tp=0, StopTrading = 0, StopTrading2 = 0;
double DontStart = 0, DontStart2 = 1;
double BuyPrice=0, SellPrice=0;
double LastPrice=0;
double lotsi=0, mylotsi=0;
double LotStep;
double MinLots=0,MaxLots=0;
double LastClosePrice=0, LastLots=0;
double Spread,WorstSpread,NormalSpread;
double point = 0;
double pipMultiplier = 1;

string text="", text2="",text3="", text4 ="", AccountText="";

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int init()
  {
  
   dg=Digits;
   if(dg==3 || dg==5)
   {
   point=Point*10;
   pipMultiplier=10;
   }
   else
   {
   point=Point;pipMultiplier=1;
   }
   
   NormalSpread=MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,dg%2);
   
// Moved from Start function

   MinLots = NormalizeDouble(MarketInfo(Symbol(),23),2);
   LotStep = NormalizeDouble(MarketInfo(Symbol(),24),2);
   MaxLots = NormalizeDouble(MarketInfo(Symbol(),25),2); 
   lotsize = MarketInfo( Symbol(), MODE_LOTSIZE );
   
   if (lotsize == 100000) { AccountisNormal = True; } else {AccountisNormal = False;}
   if (lotsize == 10000)  { AccountisNormal = False; }
   
   if (AccountisNormal == True) { AccountText = "Standard"; } else { AccountText="Mini"; }

   return(0);
  }
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int deinit() {  return(0);  }

//
//
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
  {
   
   PipValue = MarketInfo(Symbol(),16);
   if (PipValue == 0) { PipValue = 5; }
   
   if (BreakEvenAtProfit > 0) breakEvenManager();
   
   if (TrailingStop > 0) trailingStopManager();
   
   //
   //
   //
   //
   //
   
   Spread = MarketInfo(Symbol(),MODE_SPREAD)/MathPow(10,dg%2);   
   
   if (Spread > WorstSpread) WorstSpread = Spread;
   if (SpreadProtection && Spread > NormalSpread + PipTolerance) DontContinue = 1; else DontContinue = 0;
   
   //
   //
   //
   //
   //        
   
// The following code moved to init because values never change so no need to do every tick
//   MinLots = NormalizeDouble(MarketInfo(Symbol(),23),2);
//   LotStep = NormalizeDouble(MarketInfo(Symbol(),24),2);
//   MaxLots = NormalizeDouble(MarketInfo(Symbol(),25),2); 
//   lotsize = MarketInfo( Symbol(), MODE_LOTSIZE );
   
//   if (lotsize == 100000) { AccountisNormal = True; } else {AccountisNormal = False;}
//   if (lotsize == 10000)  { AccountisNormal = False; }
   
//   if (AccountisNormal == True) { AccountText = "Standard"; } else { AccountText="Mini"; }
   
   //
   //
   //
   //
   //
     
   if (AccountisNormal)
   {
	  if (mm) 
	  { 
	   if (MinLots==1)    { lotsi=MathFloor(AccountBalance()*risk/100000);   }
	   if (MinLots==0.1)  { lotsi=MathFloor(AccountBalance()*risk/10000)/10; }
	   if (MinLots==0.01) { lotsi=MathFloor(AccountBalance()*risk/1000)/100; }
	  } 
	  else 
	  { 
		lotsi=Lots; 
	  }
     } 
     else 
     {  
     if (mm) 
	  { 
	   if (MinLots==1)    { lotsi=MathFloor(AccountBalance()*risk/10000);   }
	   if (MinLots==0.1)  { lotsi=MathFloor(AccountBalance()*risk/1000)/10; }
	   if (MinLots==0.01) { lotsi=MathFloor(AccountBalance()*risk/100)/100; }
	  } 
		else 
		{ 
		lotsi=Lots; 
		}
   }
   if (lotsi>MaxLots){ lotsi=MaxLots; }
   if (lotsi<MinLots){ lotsi=MinLots; }
   
   //
   //
   //
   //
   //
   
   if (AccountMoneyProtection == true && AccountEquity() < AccountMoneyProtectionValue)
   {
    text3 = "Closing orders because account money protection was triggered.";
    Print("Closing orders because account money protection was triggered. Balance: ",AccountBalance()," Equity: ",AccountEquity());
    CloseAll();
    ContinueOpening = false;
   }
   
   //
   //
   //
   //
   //
   
   if (EquityProtection == true && AccountEquity() <= AccountBalance() * AccountEquityPercentProtection/100) 
	{
	 text3 = "Closing orders because account equity protection was triggered.";
	 Print("Closing orders because account equity protection was triggered. Balance: ",AccountBalance()," Equity: ", AccountEquity());	 
	 CloseAll();
	 ContinueOpening = false;
   }
   
   //
   //
   //
   //
   //
   
   if (AccountFreeMargin() < (AccountBalance() * MarginProtection/100)) { ContinueOpening = false; }
   else { ContinueOpening = true; }
   
   //
   //
   //
   //
   //
   
   if (AccountBalance() - AccountEquity() > (AccountBalance() * FloatingLossProtection)/100) { ContinueOpening = false; }
   else { ContinueOpening = true; }
   
   //
   //
   //
   //
   //
   
   OpenOrders = 0;
   for(cnt = 0;cnt < OrdersTotal();cnt++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic)
	  {				
	   OpenOrders++;
	  }
   }  
      
   if (OpenOrders < 1) 
   {
   }
   
   if (PreviousOpenOrders>OpenOrders) 
   {	  
	  for(cnt=OrdersTotal();cnt>=0;cnt--)
	  {
	     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  	  mode = OrderType();
		  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		  {
			if (mode==OP_BUY)  { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage*point,Blue); }
			if (mode==OP_SELL) { OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage*point, Red); }
			return(0);
		 }
	  }
   }
   
   //
   //
   //
   //
   //
   
   PreviousOpenOrders = OpenOrders;
   if (OpenOrders >= MaxTrades) 
   {
   
	  ContinueOpening=False;
	  
   } else {
   
	  ContinueOpening=True;
   }
   
   if (LastPrice==0) 
   {
	  for(cnt=0;cnt<OrdersTotal();cnt++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 mode = OrderType();	
		 if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
		 {
			LastPrice=OrderOpenPrice();
			if (mode==OP_BUY)  { myOrderType=2; }
			if (mode==OP_SELL) { myOrderType=1;	}
		 }
	  }
   }
   
   //
   //
   //
   //
   //
   
   if (OpenOrders < 1) 
   {
	  myOrderType = GetOrderType(); // Made a function for increase speed in backtest
	  
	  
	  //
	  //
	  //
	  //
	  //
	   
	  if (ReverseCondition==1)
	  {
	  	  if (myOrderType==1) { myOrderType=2; }
		  else { if (myOrderType==2) { myOrderType=1; } }
	  }
   }
   
   //
   //
   //
   //
   //
   
   Profit=0;
   LastTicket=0;
   LastType=0;
	LastClosePrice=0;
	LastLots=0;	
		
	for(cnt=0;cnt<OrdersTotal();cnt++)
	{
	  OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	  {			
	  	   LastTicket=OrderTicket();
			if (OrderType()==OP_BUY)  { LastType=OP_BUY; }
			if (OrderType()==OP_SELL) { LastType=OP_SELL; }
			LastClosePrice=OrderClosePrice();
			LastLots=OrderLots();
			if (LastType==OP_BUY) 
			{	
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit-(OrderOpenPrice()-OrderClosePrice())*OrderLots()/point*Point; }
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit+(OrderClosePrice()-OrderOpenPrice())*OrderLots()/point*Point; }
			}
			if (LastType==OP_SELL) 
			{
				if (OrderClosePrice()>OrderOpenPrice()) 
					{ Profit=Profit-(OrderClosePrice()-OrderOpenPrice())*OrderLots()/point*Point; }
				if (OrderClosePrice()<OrderOpenPrice()) 
					{ Profit=Profit+(OrderOpenPrice()-OrderClosePrice())*OrderLots()/point*Point; }
			}
	
	//
	//
	//
	//
	//
	
	Profit = Profit * PipValue;
	text2  = "Profit: $"+DoubleToStr(Profit,2)+" +/-";
	
   if (OpenOrders >=(MaxTrades - OrderstoProtect) && AccountProtection == 1) 
   {	    
	     if (Profit >= SecureProfit) 
	     {
	        OrderClose(LastTicket,LastLots,LastClosePrice,slippage * point,Yellow);		 
	        ContinueOpening=False;
	        return(0);
	     }
    }
    
    //
    //
    //
    //
    //
    
    if (CloseOnTrendRev)
	  	  {
	  	    if (myOrderType == 1 && TrendType != 2 && Profit >= SecureProfit) 
	  	      {
	  	      
	          CloseAll();
	          ContinueOpening=False;
		       myOrderType=0;
		       
		       return(0);
		      }
		      
	  	    if (myOrderType == 2 && TrendType != 1 && Profit >= SecureProfit) 
	  	      {
	  	      
	          CloseAll();
	          ContinueOpening=False;
		       myOrderType=0;
		       
		      return(0);
		   }
		 }
	  }   
   }
   
   //
   //
   //
   //
   //
   
    if (!IsTesting()) 
      {
        
	     if (myOrderType==3) { text = "No conditions to open trades"; }
	     
	     else { text="    "; }
	     
	     Comment(" Account Type: ",AccountText,"\nLastPrice=",LastPrice," Previous open orders=",PreviousOpenOrders,"\nContinue opening=",ContinueOpening," OrderType=",myOrderType,"\nLots=",lotsi,"\n",text,"\nNormal Spread=",
	               NormalSpread,"\nActual Spread=",Spread,"\nWorst Spread=",WorstSpread,"\n",text3,"\n",text4); 
      }
      
      //
      //
      //
      //
      //

      if (myOrderType==1 && ContinueOpening && DontContinue==0 && TimeCondition()) 
      {	
	     if ((Bid-LastPrice)>=Pips*point || OpenOrders<1) 
	     {		
		    SellPrice=Bid;				
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=SellPrice-TakeProfit*point; }	
		    if (InitialStop==0) { sl=0; }
		    else { sl=NormalizeDouble(SellPrice+InitialStop*point + (MaxTrades-OpenOrders)*Pips*point,dg);  }
		    if (OpenOrders!=0) 
		    {
			      mylotsi=lotsi;			
			      for(cnt=1;cnt<=OpenOrders;cnt++)
			      {
				     if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				     else { mylotsi=NormalizeDouble(mylotsi*lotincrease,2); }
			      }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    
		    //
		    //
		    //
		    //
		    //
		    
		    if (!EcnBroker)
   		       OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage*point,sl,tp,"smi sell",Magic,0,Red);		    		    
          else
             {
                int sellTicket = OrderSend(Symbol(),OP_SELL,mylotsi,SellPrice,slippage*point,0,0,"smi sell",Magic,0,Red);		    		    
                if (sellTicket >= 0)
                     OrderModify(sellTicket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
             }		       
		    return(0);
	     }
      }
      
      //
      //
      //
      //
      //
      
      if (myOrderType==2 && ContinueOpening && DontContinue==0 && TimeCondition()) 
      {
	     if ((LastPrice-Ask)>=Pips*point || OpenOrders<1) 
	     {		
		    BuyPrice=Ask;
		    LastPrice=0;
		    if (TakeProfit==0) { tp=0; }
		    else { tp=BuyPrice+TakeProfit*point; }	
		    if (InitialStop==0)  { sl=0; }
		    else { sl=NormalizeDouble(BuyPrice-InitialStop*point - (MaxTrades-OpenOrders)*Pips*point,dg); }
		    if (OpenOrders!=0) {
			   mylotsi=lotsi;			
			   for(cnt=1;cnt<=OpenOrders;cnt++)
			   {
				  if (MaxTrades>12) { mylotsi=NormalizeDouble(mylotsi*1.5,2); }
				  else { mylotsi=NormalizeDouble(mylotsi*lotincrease,2); }
			   }
		    } else { mylotsi=lotsi; }
		    if (mylotsi>100) { mylotsi=100; }
		    
		    //
		    //
		    //
		    //
		    //
		    
		    if (!EcnBroker)
   		       OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage*point,sl,tp,"smi buy",Magic,0,Blue);		    
          else
             {
                int buyTicket = OrderSend(Symbol(),OP_BUY,mylotsi,BuyPrice,slippage*point,0,0,"smi buy",Magic,0,Blue);
                if (buyTicket >= 0)
                     OrderModify(buyTicket,OrderOpenPrice(),sl,tp,0,CLR_NONE);
             }		       
		    return(0);
	     }
      }   

   return(0);
  }
  
//
//
//
//
//
  
bool TimeCondition()
{
   bool result = false;
   
   datetime SessionStart = StrToTime(StartHour+":"+StartMinute);
   datetime SessionEnd   = StrToTime(EndHour+":"+EndMinute);
   
   if (StartHour < EndHour)
   result = TimeCurrent() >= SessionStart && TimeCurrent() < SessionEnd;      
   else
   if (StartHour > EndHour)
   result = (TimeCurrent() >= SessionStart && TimeHour(TimeCurrent()) < 24)
          ||(TimeHour(TimeCurrent()) >= 0 && TimeCurrent() < SessionEnd);
   
return(result);
}  

//
//
//
//
//

void trailingStopManager() 
{
   cnt=OrdersTotal();
   while(cnt>=0)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
	  {
   	     
	  	  if (OrderType()==OP_SELL) 
	  	  {			
	  	  	  if (TrailingStop>0) 
			  {
				  if ((OrderOpenPrice()-Ask)>=(TrailingStop*point+Pips*point)) 
				  {						
					 if (OrderStopLoss()>(Ask+point*TrailingStop) || OrderStopLoss()==0)
					 {					
					    OrderModify(OrderTicket(),OrderOpenPrice(),Ask+point*TrailingStop,OrderClosePrice()-TakeProfit*point-TrailingStop*point,0,Purple);
	  					 return(0);	  					
	  				 }
	  			  }
			  }
	  	  }
   
	  	  if (OrderType()==OP_BUY)
	  	  {
	  		 if (TrailingStop>0) 
	  		 {
			   if ((Bid-OrderOpenPrice())>=(TrailingStop*point+Pips*point)) 
				{
					if (OrderStopLoss()<(Bid-point*TrailingStop)) 
					{
					   OrderModify(OrderTicket(),OrderOpenPrice(),Bid-point*TrailingStop,OrderClosePrice()+TakeProfit*point+TrailingStop*point,0,Yellow);
                  return(0);
					}
  				}
			 }
	  	  }
   	}
      cnt--;
   }
 }
   
//
//
//
//
//

void breakEvenManager() 
{

   cnt=OrdersTotal();
   while(cnt>=0)
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
	  {
	  
	   if (OrderType() == OP_BUY)
      {

       if (BreakEvenAtProfit > 0)
       {
         
            if (Bid-OrderOpenPrice() >= point * BreakEvenAtProfit)
            {
               if (OrderStopLoss()!=OrderOpenPrice() + BreakEvenShift * point)
               
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+ BreakEvenShift * point,OrderTakeProfit(),0,Green); 
            }
         }
         else if (OrderType() == OP_SELL)
         {
            if (OrderOpenPrice()-Ask >= point * BreakEvenAtProfit)
            {
               if (OrderStopLoss()!=OrderOpenPrice() - BreakEvenShift * point)
               
                  OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice() - BreakEvenShift * point,OrderTakeProfit(),0,Red); 
            }
         }
      }
   }
}
}

//
//
//
//
//

void CloseAll()
{
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    int type   = OrderType();
    bool result = false;
    if (OrderSymbol() != Symbol())    continue;
    if (OrderMagicNumber() != Magic)  continue;
    
     switch(type)
     {
    
      case OP_BUY       : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_BID),slippage,Blue);
                          break;
      
      
      case OP_SELL      : result = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(), MODE_ASK),slippage,Red);
                          
     }
    }
  myOrderType=0;
}  

// Modified for speed in backtesting
// Since all compares use && when an y one fails there is no need to check the rest
// NOTE : This function also sets a global variable TrendType if a buy or sell is triggered
int GetOrderType()
{
//	  myOrderType=3;
	  
	  if (iCustom(NULL,rbcitf1,"normalized T3 Rbci",NormPeriod,RbciPrice,T3Period,T3Hot,T3Original,false,0,bar) > iCustom(NULL,rbcitf1,"normalized T3 Rbci",NormPeriod,RbciPrice,T3Period,T3Hot,T3Original,false,0,bar+1))  
	  {
	  //BUY
	  //
	  //
	  //
	  // Here we check for failures to exit early from function by replacing > with <
	  // If a rule fails return 3 and no change to TrendType
	  
	    if (iCustom(NULL,rbcitf2,"normalized T3 Rbci",NormPeriod,RbciPrice,T3Period,T3Hot,T3Original,false,0,bar) < iCustom(NULL,rbcitf2,"normalized T3 Rbci",NormPeriod,RbciPrice,T3Period,T3Hot,T3Original,false,0,bar+1)) return(3); 
	    if (iCustom(NULL,stlmtf,"T3 Stlm_histo",T3Period,T3Hot,T3Original,4,bar)                                  < iCustom(NULL,stlmtf,"T3 Stlm_histo",T3Period,T3Hot,T3Original,4,bar+1)) return(3);
	    if (iCustom(NULL,fatltf,"T3_Fatl",T3Period,T3Hot,T3Original,false,0,bar)                                  < iCustom(NULL,fatltf,"T3_Fatl",T3Period,T3Hot,T3Original,false,0,bar+1)) return(3); 
	    if (iCustom(NULL,satltf,"T3_Satl",T3Period,T3Hot,T3Original,false,0,bar)                                  < iCustom(NULL,satltf,"T3_Satl",T3Period,T3Hot,T3Original,false,0,bar+1)) return(3);

	   // If we get here then all rules passed for BUY trade signal

	     TrendType=2; 
	     return(2); // myOrderType = 2; 
	  }
	  else
	  {
	  //SELL
	  //
	  //
	  //
	  // Here we check for failures to exit early from function by replacing < with >
	  
	     if (iCustom(NULL,rbcitf2,"normalized T3 Rbci",NormPeriod,RbciPrice,T3Period,T3Hot,T3Original,false,0,bar) > iCustom(NULL,rbcitf2,"normalized T3 Rbci",NormPeriod,RbciPrice,T3Period,T3Hot,T3Original,false,0,bar+1))  return(3); 
	     if (iCustom(NULL,stlmtf,"T3 Stlm_histo",T3Period,T3Hot,T3Original,4,bar)                                  > iCustom(NULL,stlmtf,"T3 Stlm_histo",T3Period,T3Hot,T3Original,4,bar+1)) return(3);
	     if (iCustom(NULL,fatltf,"T3_Fatl",T3Period,T3Hot,T3Original,false,0,bar)                                  > iCustom(NULL,fatltf,"T3_Fatl",T3Period,T3Hot,T3Original,false,0,bar+1)) return(3);
	     if (iCustom(NULL,satltf,"T3_Satl",T3Period,T3Hot,T3Original,false,0,bar)                                  > iCustom(NULL,satltf,"T3_Satl",T3Period,T3Hot,T3Original,false,0,bar+1)) return(3);

	   // If we get here then all rules passed for SELL trade signal

	      TrendType=1;
	      return(1); // myOrderType = 1;  

	  }
}

